
/*
 * Example of the use of open_scan() function.
 */

#include <iostream.h>

int main(int argc, char **argv)
{
    cout << "scan3.S: Demonstrating open_scan().\n";

    init_coral(argv[0]);
  
    \[
      clear(interactive_mode).
    \]

    // Enter some sample data (with lists)
    \[
      data(1, [2,1,3,4,5,6]).    % yes
      data(2, [2,1,3,4,5,6]).
      data(3, [1,2,3,4,5,6]).
      data(2, [1,2,3,4,5,6]).    % yes
      data(0, [0,0,0,4,0,6]).    % yes
      data(6, [6,0,0,6,6,6]).
      data(6, [6,6,0,6,6,6]).    % yes
      data(5, [5,6,5,5,5,6]).
      data(9, [9,6,0,0,0,0]).
    \]

      // Want only items where second item in list matches
      // first argument.
    Cor_ScanDesc *scan = open_scan("data(X, [_,X|_]).");

    ASSERT(scan);

    Cor_Tuple *tuple;

      /* Iterate over the tuples in the relation */
    for (tuple = scan->next_tuple(); !(scan->no_match());
                     tuple = scan->next_tuple()) {

          // Print them out as tuples 
        cout << "data(" << *tuple << ").\n";
    }

    exit_coral();

    return(0);
}

