%
% Test for response to all solvers
%
clear(interactive_mode).
set(insert_mode).

shell("/bin/rm -f tmp tmp.P tmp.T").


?abs(3.2,A1).
?abs(-2,A2).
?abs(-4.4,A3).

?ceiling(2.2,B1).
?ceiling(-3.2,B2).
?ceiling(4,B2).

?floor(2.2,C1).
?floor(-3.2,C2).
?floor(4,C2).

% set manipulation builtins
?add_elem(mary,{mark,jake,jim},D1).
?add_elem(mark,{mark,jake,jim},D2).
?add_elem(mark,{},D3).

?E1={mark,jake,jim}, add_elem_d(mary,E1), print(E1), printf("\n").
?E2={mark,jake,jim}, add_elem_d(mark,E2), print(E2), printf("\n").
?E3={}, add_elem_d(mark,E3), print(E3), printf("\n").

?call(printf("call works!\n")).

?create_set(F1).

?member({mark,jake,jim},G1).

bands(bjork,sugar_cubes).
bands(nin,jars_of_clay).
?member(bands,G1,G2).
rel_close(bands(_,_)).

% Need to figure this out
%?memtuple

?subset({mark,jake,jim}, {jake,jim}).
?subset({mark,jake,jim}, {pat,jim}).

?unionsum({mark,jake,jack},{jack,tom,larry}, J1).
?unionsum({mark,jake},{jack,tom,larry}, J2).
?unionsum({mark,jake},{}, J3).
?unionsum({},{}, J4).

?unionmax({mark,jake,jack},{jack,tom,larry}, K1).
?unionmax({mark,jake},{jack,tom,larry}, K2).
?unionmax({mark,jake},{}, K3).
?unionmax({},{}, K4).

?L1={jack,tom,larry},unionsum_d({mark,jake,jack}, L1), print(L1),printf("\n").
?L2={jack,tom,larry},unionsum_d({mark,jake}, L2), print(L2),printf("\n").
?L3={},unionsum_d({mark,jake}, L3), print(L3),printf("\n").
?L4={},unionsum_d({}, L4), print(L4),printf("\n").

?M1={jack,tom,larry},unionmax_d({mark,jake,jack},M1), print(M1),printf("\n").
?M2={jack,tom,larry},unionmax_d({mark,jake},M2), print(M2),printf("\n").
?M3={},unionmax_d({mark,jake},M3), print(M3),printf("\n").
?M4={},unionmax_d({},M4), print(M4),printf("\n").

?functor(pea(_,_,5), N1, N2).
?functor(pod(), N3, N4).

?arg(3,pea(1,2,3),Q1).
?arg(2,pea(1,2,3),Q2).

?univ(pea(1,2,3), R1).
?univ(pod(), R2).


?inter({mark,jake,jack},{jack,tom,larry}, S1).
?inter({mark,jake},{jack,tom,larry}, S2).
?inter({},{}, S3).

?difference({mark,jake,jack},{jack,tom,larry}, S4).
?difference({mark,jake},{jack,tom,larry}, S5).
?difference({},{}, S6).

?make_set({mark,jake,jack}, S7).
?make_set({mark,jake,mark,jack,mark}, S8).

?T1={jack,tom,larry}, inter_d({mark,jake,jack}, T1), print(T1), printf("\n").
?T2={jack,tom,larry}, inter_d({mark,jake}, T2), print(T2), printf("\n").
?T3={}, inter_d({}, T3), print(T3), printf("\n").

?T4={jack,tom,larry}, difference_d({mark,jake,jack},T4),print(T4),printf("\n").
?T5={jack,tom,larry},difference_d({mark,jake},T5), print(T5), printf("\n").
?T6={},difference_d({},T6), print(T6), printf("\n").

?T7={mark,jake,jack},make_set_d(T7), print(T7), printf("\n").
?T8={mark,jake,mark,jack,mark},make_set_d(T8), print(T8), printf("\n").

?pow(2,5,U1).
?pow(2,U2,32).
?pow(U3,5,32).


% string manipulation builtins
?length("hello",V1).
?length("",V2).
?length(hiya,V2).

?extract(hello,0,W1).
?extract(hello,3,W2).

?substr(hello, lo, W3).
?substr("Hey_you?", "_", W4).


% Print builtins
%?print_empty
%?print_bindings
%?print_tuple
%?print_literal

?print("Hello there\n").
?printf("Hello there %d\n", 5).

%?scanf
%?print_module

% Builtin relations
alias_rel(forgot,help).
?forgot(query).

%assign
%clear
%consult 

?cputime(W5).

%delete

reset_timer.
display_timer.

%explain_off
%explain_on

help(query).
history.

%insert
pipein("echo 'my(hi).'").
?my(X).

pipeout("cat > tmp", my(X)).

shell("ls").

%profile_off
%profile_on

%set
%set_break
%clear_break

%trace_on
%trace_off
write_table(my(_), "tmp.T").

show_mem.

% Array stuff is out-dated
%?array(X,3), bind(X,0,zero), bind(X,1,one), bind(X,2,two), print(X),
% lookup(X,W7,W8), destruct(X).


% Builtin relations for suspensions and client/server operation
% Since we are not in client/server mode, test lightly.
answer.
answer(10).

whoami.

%kill
%list_sus
%login
%logout
%resume
%socket_rel

sync.
sync(2).

%user
who.
%yield.

% Counter Stuff
reset_c_counter(2).
?c_counter(W9).
?c_counter(W9).
?c_counter(W9).

% Builtin relations to deal with multiple workspaces( nee\ databases
?ws_current(X1).

ws_create("new_workspace").
ws_current("new_workspace").
my(2).
my(3).
my(4).
list_rels.
ws_save(tmp.P).
ws_rename("new_workspace", other).
ws_save(tmp.P,other).
list_ws.
list_rels.
ws_current(default_ws).

rel_open(my(_),other).
rel_copy(my(_),other,yours(_)).
rel_add(my(_),other,yours(_)).
rel_clear(yours(_)).
rel_close(my(_)).

list_ws.
ws_clear(other).
ws_destroy(other).

% Builtin relations to handle the default execution environment
reset_defaults.
display_defaults.

% Builtin relations to check the type of an arg
?is_constant(2).
?is_var(X).
?is_list([3,4]).
?is_functor(hello(x)).
?is_string("hi").
?is_num(5.6).
?is_int(6).
?is_long(4.2).
?is_short(4).
?is_float(4.2).
?is_double(4.2).

% This one has to be tested last. :)
quit.
