module pipe_eg12.
@pipelining.

export multiset_to_list(bf).

% The first argument must be bound to a multiset; returns a list
% with the same elements.

multiset_to_list(S,L) :- create_set(S2), mtol(S,S2,L).

mtol(S1, S2, [X|L]) :- 
        difference(S1, S2, S), 
        member(S,X),
        add_elem(X,S2,Snew),
        mtol(S1, Snew, L), !.

mtol(S1, S2, []) :- 
        difference(S1, S2, S), count(S,N), N is 0.

end_module.

