#ifndef _RDBINGRESQUERY_H_
#define _RDBINGRESQUERY_H_

#include "RdbQuery.h"
#include "RdbJoin.h"
#include "bitvector.h"
#include "RdbIngresSqlda.h"


class RdbIngresQuery
: public RdbQuery
{
  public:

    RdbIngresQuery(const RdbJoin& newJoin, const BitVector& newAdorn);
				// create an ingres query on this join
				// with this expected adornment

    ~RdbIngresQuery();

    virtual void const* Implementor() const; // access to 'this'

  private:

    RdbIngresSqlda resultDA;	// result of query

    RdbIngresSqlda whereDA;	// bindings

    static unsigned queryNum;	// first one better be free when this
				// rolls over!!

    static unsigned cursorNum;	// ditto!
    
    ErrorCode Bind(const RdbItemList& bindings); 
				// copies bindings into an whereDA

    ErrorCode Describe();	// prepares the result and where data areas

    void SetCursorId(RdbCursor& cursor, String* id);

    String& GetCursorId(RdbCursor& cursor);

    virtual ErrorCode VOpen( RdbCursor& cursor );
				// open cursor on this query

    virtual ErrorCode VClose( RdbCursor& cursor );
				// close cursor 

    virtual ErrorCode VGetNext( RdbCursor& cursor, RdbItemList& result );
				// get the next item from the cursor
				// storing answer in result

    RdbIngresQuery(const RdbIngresQuery&); // na

    RdbIngresQuery& operator =(const RdbIngresQuery&); // na
};


#include "RdbIngresQuery.i"

#endif // _RDBINGRESQUERY_H_
