// *************************************************************************
//    Trail.C
// *************************************************************************

#include "Trail.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
// The Trail is a stack of TrailElements, which are (bindenv,variable) pairs.
// It is used to remember information that can be undone by PopTrail.
// If a TrailElement.var is non-negative, it marks a binding that as
// been pushed so that PopTrail can undo it.
// If the index is negative, the entire bindenv is to be deleted by PopTrail
// *************************************************************************

// *************************************************************************
Cor_Trail::Cor_Trail(int size)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Limit = size;
    Stack = new TrailElement[Limit];
    TrailSize = 0;
}

// *************************************************************************
Cor_Trail::~Cor_Trail()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    delete [] Stack;
}

// *************************************************************************
