// *************************************************************************
//    ModulePred.h
// *************************************************************************

#ifndef _ModulePred_H_
#define _ModulePred_H_

#include "PredAnnotations.h"
#include "ArgList.h"

// *************************************************************************

class Cor_Predicate;

// *************************************************************************

class Cor_AnnoStruct {

  public:

    Cor_PredAnnotations *anno;
    int num_vars;
    Cor_AnnoStruct *next;

    Cor_AnnoStruct(Cor_PredAnnotations *a, int vars,
                Cor_AnnoStruct *nxt) {
        anno = a;
        num_vars = vars;
        next = nxt;
    }

   ~Cor_AnnoStruct() {
        // SPF - I don't think we own this
        //anno->delete_list();
    }
};

// *************************************************************************

enum PredKind {
    QueryPredKind,
    MagicQueryPredKind,
    LocalPredKind,
    ExternalPredKind
};

// *************************************************************************

class Cor_ModulePred {

  public:
    Cor_Predicate         *pred;
    PredKind               kind;
    int                    check_subsum;
    int                    disk_rel;
    Cor_ArgList           *schema_def;
    int                    offset;
    Cor_AnnoStruct        *index_annos;
    Cor_AnnoStruct        *aggsel_annos;
    Cor_ModulePred        *next;

    Cor_ModulePred(Cor_Predicate *p) {
        pred = p;
        next = NULL;
        schema_def   = NULL; 
        index_annos  = NULL;
        aggsel_annos = NULL;
    }

   ~Cor_ModulePred() {
        Cor_AnnoStruct *curr, *prev = NULL;

        for (curr = index_annos; curr; curr=curr->next) {
            delete prev;
            prev = curr;
        }

        for (curr = aggsel_annos; curr; curr=curr->next) {
            delete prev;
            prev = curr;
        }
        delete prev;
    }
};

// *************************************************************************

#endif _ModulePred_H_
