// *************************************************************************
//    SccEnv.C
// *************************************************************************

#include "SccEnv.h"

#include "SccInfo.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_SccEnv::Cor_SccEnv(Cor_SccInfo *parent)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int i;

    parent_scc = parent;
    numSNRules = parent->numSNRules;

#ifdef ASYN_SOCK_REL
    rm_Arr = new Cor_RMarkArray(2*(parent->numPreds
        + parent->num_lowerPreds + parent->numSockRelPreds));
#else
    rm_Arr = new Cor_RMarkArray(2*parent->numPreds);
#endif
    
    snrule_envs = new Cor_RuleEnv* [numSNRules];
    for (i = 0; i < numSNRules; i++)
        snrule_envs[i] = new Cor_RuleEnv(&(parent->sn_rules[i]));
}

// *************************************************************************
Cor_SccEnv::~Cor_SccEnv()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    delete rm_Arr;

    for (int i = 0; i < numSNRules; i++)
        delete snrule_envs[i];
    delete [] snrule_envs;
}

// *************************************************************************
// Clear out the tuple iterators
void Cor_SccEnv::clear_tupits()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    for (int i = 0; i < numSNRules; i++)
        if (snrule_envs[i])
            (snrule_envs[i])->clear_tupits();
}

// *************************************************************************
