// *************************************************************************
//    TermList.h
// *************************************************************************

#ifndef _TermList_H_
#define _TermList_H_

#include "ArgList.h"
#include "Literal.h"

// *************************************************************************
// Structure used to keep track of function terms that have been replaced
// by dummy variables in order to generate rules in Extended Datalog form.

typedef struct TermList TermList;

struct TermList {
    Cor_ArgList *arg_list;           // ArgList that held the term
    int arg_pos;                     // Position of term within ArgList
    Cor_CArg *var_arg;               // Dummy variable used
    Cor_CArg *func_arg;              // Original functor arg replaced
    Cor_Literal *dummy_pred;         // Dummy predicate introduced
    struct TermList *similar;        // Pointer to an identical TermList struct
                                     // if such exists
    struct TermList *next;

    TermList();
    TermList(Cor_ArgList *alist, int apos);
    void set_vararg(Cor_CArg *varg)       { var_arg = varg; }
    void set_funcarg(Cor_CArg * farg)  { func_arg = farg; }
    void set_similar(TermList *t)         { similar = t; }
};

// *************************************************************************

#endif _TermList_H_
