// *************************************************************************
//    Stack.h
// *************************************************************************

#ifndef _Stack_H_
#define _Stack_H_

#include <stdlib.h>

// *************************************************************************

class StringStack {

  public:
    char **data;
    int    length;
    int    data_size;

    StringStack() {
                     data = NULL;
                     length = 0;
                     data_size = 0;
                   }
    StringStack(int sze) {
                            data = new char* [sze];
                            length = 0;
                            data_size = sze;
                          }

   ~StringStack() { empty(); delete [] data; }

    int  count() { return(length); }
    int  is_empty() { return(length == 0); }

      // push() returns the position
    int  push(char *item);

        // Pull out the last element
    char *pop() {
        if (length > 0) {
            length--;
            return(data[length]);
        } else {
              // Not the best, need to be careful not to exceed
            return(NULL);
        }
    }

    char *get_ith(int i) {
        if (length > i)
            return(data[i]);
        return(NULL);
    }

      // Empty out the stack
    void empty() {
        for (int j=0; j < length; j++)
            delete [] data[j];
        length = 0;
    }
};

// *************************************************************************

#endif _Stack_H_
